﻿@*@using Easy4Us.Application.Interfaces
@using Easy4Us.Application.DTO

@using Easy4Us.Infra.CrossCutting.Common.Interfaces

@inject NavigationManager NavigationManager
@inject IUserAccessor  UserAccessor
@inject ICustomerAppService CustomerAppService

@if (Campaign == null)
{
    <div class="card shadow-lg">
        <div class="card-header font-weight-bold">
            <div class="container-fluid">
                <div class="row">
                    <div class="col-sm-8">No Campaign Selected</div>
                </div>
            </div>
        </div>
        <div class="card-body">
            <div class="container">
                <div class="row">
                    <div class="col-8">
                        <p>No description avaiable.</p>
                    </div>
                    <div class="col-4">
                        <ul>
                            <li>Customers: @customerNumber</li>
                            <li>Cleared: @cleared</li>
                            <li>Updated: @lastUpdated</li>
                        </ul>
                        <div class="float-right">
                            <button class="btn btn-primary" @onclick="Refresh">Refresh</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
}
else
{
    <div class="card shadow-lg">
        <div class="card-header font-weight-bold">
            <div class="container-fluid">
                <div class="row">
                    <div class="col-sm-8">Campaign: @Campaign.Name</div>
                    <div class="col-sm-4">
                        <BSButtonGroup Class="float-right">
                            <BSDropdown>
                                <BSDropdownToggle Color="Color.Secondary">Campaigns</BSDropdownToggle>
                                <BSDropdownMenu Class="bs-dropdown-left">
                                    @foreach (var campaign in Campaigns)
                                    {
                                        <BSDropdownItem OnClick="@(() => OnClickCampaign.InvokeAsync(campaign))">@campaign.Name</BSDropdownItem>
                                    }
                                </BSDropdownMenu>
                            </BSDropdown>
                        </BSButtonGroup>
                    </div>
                </div>
            </div>
        </div>
        <div class="card-body">
            <div class="container-fluid">
                <div class="row">
                    <div class="col-8">
                        <p>@Campaign.Description</p>
                    </div>
                    <div class="col-4">
                        <ul>
                            <li>Customers: @customerNumber</li>
                            <li>Cleared: @cleared</li>
                            <li>Updated: @lastUpdated</li>
                        </ul>

                    </div>
                    <div class="w-100"></div>
                    <div class="col-8">
                        <span>
                            @Campaign.StartDate.ToString("dd MMM, yyyy")
                            to
                            @Campaign.EndDate.ToString("dd MMM, yyyy")
                        </span>
                    </div>
                    <div class="col-4">
                        <button class="btn btn-primary float-right" @onclick="Refresh">Refresh</button>
                    </div>
                </div>
                <div class="row">
                </div>
            </div>
        </div>
    </div>
}

@code {
    [Parameter]
    public CampaignDTO Campaign { get; set; }

    [Parameter]
    public IEnumerable<CampaignDTO> Campaigns { get; set; }

    [Parameter]
    public IEnumerable<CustomerDTO> Customers { get; set; }

    [Parameter]
    public EventCallback<CampaignDTO> OnClickCampaign { get; set; }

    private int customerNumber = 0;
    private int cleared = 0;
    private string lastUpdated = "Never";

    protected override void OnParametersSet()
    {
        if (Customers != null && Customers.Count() > 0)
        {
            customerNumber = Customers.Count();
            cleared = Customers.Where(x => x.USP == Domain.Enums.ValidationStatus.VALID &&
                                         x.GAMA == Domain.Enums.ValidationStatus.VALID &&
                                         x.SFDC == Domain.Enums.ValidationStatus.VALID &&
                                         x.NewEasy == Domain.Enums.ValidationStatus.VALID).Count();
            lastUpdated = Customers.LastOrDefault().LastUpdated.ToString("dd MMM, yyyy HH:mm tt");
        }
    }

    protected void Refresh()
    {
        var displayName = UserAccessor.GetCurrentUserDisplayName();

        CustomerAppService.Refresh(Campaign?.Name ?? "", displayName);

        NavigationManager.NavigateTo("\\");
    }
}*@
